'use strict';

exports.__esModule = true;
exports.default = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('./IModal.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IModal = function (_Component) {
    _inherits(IModal, _Component);

    function IModal() {
        var _temp, _this, _ret;

        _classCallCheck(this, IModal);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.confirmButton = function (onConfirm) {
            return _this.closeModal(onConfirm);
        }, _this.declineButton = function (onDecline) {
            return _this.closeModal(onDecline);
        }, _this.closeModal = function (actionBtn) {
            var modalNode = _this.modal; //dom node .app-modal

            modalNode.classList.remove('active');
            modalNode.classList.add('leaving');

            setTimeout(function () {
                // trigger the action after submit button
                actionBtn();

                // call callback applied to the props            
                _this.props.onClose();
            }, 200);
        }, _this.overlayClick = function (e) {
            if (!e.target.classList.contains('app-modal-overlay')) return;

            _this.declineButton(_this.props.onDecline);
        }, _this.draggable = function (parent) {
            var parentNode = parent.childNodes[0]; // .app-modal
            var modal = parent.childNodes[0].childNodes[0]; // .app-modal-body
            var modalHeader = parent.childNodes[0].childNodes[0].childNodes[0]; // .app-modal-header

            var mouseUp = function mouseUp() {
                document.removeEventListener("mousemove", positions);
                document.removeEventListener("mouseup", mouseUp);
            };

            var positions = function positions(ev) {
                var pX = ev.x - parentNode.offsetWidth / 2;
                // position Y of  half of .app-modal, half of .app-modal-body and half of .app-modal-header
                // to achieve the half of header center move positions
                var pY = ev.y - parentNode.offsetHeight / 2 + (modal.offsetHeight / 2 - modalHeader.offsetHeight / 2);

                modal.style.left = pX + "px";
                modal.style.top = pY + "px";

                document.addEventListener('mouseup', mouseUp);
            };

            // when drag mouse over the header...
            modalHeader.addEventListener('mousedown', function (e) {
                document.addEventListener('mousemove', positions);
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    IModal.prototype.render = function render() {
        var _this2 = this;

        var _props = this.props,
            className = _props.className,
            desktopDraggable = _props.desktopDraggable,
            title = _props.title,
            content = _props.content,
            confirmText = _props.confirmText,
            declineText = _props.declineText,
            onConfirm = _props.onConfirm,
            onDecline = _props.onDecline,
            open = _props.open,
            alertMode = _props.alertMode;


        if (!open) return null;

        return _react2.default.createElement(
            'div',
            { className: 'app-modal ' + className, ref: function ref(modal) {
                    var desktopDraggable = _this2.props.desktopDraggable;


                    if (modal === null) return;

                    // add class with smoothness
                    setTimeout(function () {
                        return modal.classList.add('active');
                    }, 0);

                    // enable this feature only on desktop
                    window.innerWidth > 1023 && desktopDraggable && _this2.draggable(modal);

                    return _this2.modal = modal;
                } },
            _react2.default.createElement(
                'div',
                { className: 'app-modal-overlay', onClick: this.overlayClick },
                _react2.default.createElement(
                    'div',
                    { className: 'app-modal-body' },
                    _react2.default.createElement(
                        'div',
                        { className: 'app-modal-header', style: { cursor: !desktopDraggable && 'default' } },
                        title
                    ),
                    _react2.default.createElement(
                        'div',
                        { className: 'app-modal-content' },
                        content
                    ),
                    _react2.default.createElement(
                        'div',
                        { className: 'app-modal-footer' },
                        _react2.default.createElement(
                            'div',
                            { className: 'button confirm', onClick: function onClick() {
                                    return _this2.confirmButton(onConfirm);
                                } },
                            confirmText
                        ),
                        !alertMode && _react2.default.createElement(
                            'div',
                            { className: 'button cancel', onClick: function onClick() {
                                    return _this2.declineButton(onDecline);
                                } },
                            declineText
                        )
                    )
                )
            )
        );
    };

    return IModal;
}(_react.Component);

exports.default = IModal;


IModal.propTypes = process.env.NODE_ENV !== "production" ? {
    content: _propTypes2.default.node.isRequired,
    onClose: _propTypes2.default.func,
    onConfirm: _propTypes2.default.func,
    onDecline: _propTypes2.default.func,
    title: _propTypes2.default.string.isRequired,
    className: _propTypes2.default.string,
    confirmText: _propTypes2.default.string,
    declineText: _propTypes2.default.string,
    desktopDraggable: _propTypes2.default.bool,
    open: _propTypes2.default.bool,
    alertMode: _propTypes2.default.bool
} : {};

IModal.defaultProps = {
    content: _react2.default.createElement(
        'p',
        null,
        'Default content'
    ),
    onClose: function onClose() {},
    onConfirm: function onConfirm() {},
    onDecline: function onDecline() {},
    title: 'Title',
    className: '',
    confirmText: 'Confirm',
    declineText: 'Cancel',
    desktopDraggable: true,
    alertMode: false
};
module.exports = exports['default'];